//+------------------------------------------------------------------+
//|                                             Awaiter Template.mq5 |
//|                                Copyright 2021, Centropolis Corp. |
//|                                           https://centropolis.tk |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, Centropolis Corp."
#property link      "https://centropolis.tk"
#property version   "1.00"

double LastLow;
double LastHigh;

int Spread=10000000;
int HighSpread=10000000;
int LowSpread=10000000;

int PrevSpread=10000000;
int PrevHighSpread=10000000;
int PrevLowSpread=10000000;

int HistoryDaysLoadI=365;//история трейдов за последний год

///.............автоматически генерируемые значения...........
bool bAntiSpreadNoize = true;//использовать режим подавления спредовых шумов
double C1[] = { 1,0.729902909477196,0.201981212658762,0.180705771805135,0.131598867837263,0.0575991302125474,0.0229680525674959,0.00511072854088536,0.00270930750339156,0.001890858079472,0.00168827275547086,0.00083155495456859,0.000219153167059367,0.000102718901079113,3.53508113008356E-05,6.93382104586297E-06,3.99781351967122E-06,2.41644968418629E-06,4.81643847329394E-07 };//массив для коэффициентов
int CNum=91;//количество свечей в формуле
int DeepBruteX=6;//глубина формулы
string Method="PHYSICS";//метод
int DatetimeStart=1639964700;//стартовая точка времени
bool bInvert=false;//Trade Invert
input int DaysToFuture=3000;//Days To Future
int DaysToTrade[]={ 2,4,5 };//Days To Trade
bool bCloseInOutOfTime=false;//Close Out Of Time
///...........................................................


#include <Trade\PositionInfo.mqh>
#include <Trade\Trade.mqh>
CPositionInfo  m_position;                   // trade position object
CTrade         m_trade;                      // trading object

enum LOT_VARIATION
   {
   SIMPLE_LOT,
   VARIATION_LOCAL_INCREASE,
   VARIATION_LOCAL_DECREASE,
   MARTINGALE
   };


input LOT_VARIATION LotMode=SIMPLE_LOT;//Lot Mode
bool bPrintValue=false;//Signal To Log

///крутим ручками
double ValueOpenEMax=1000000.0;//Open Signal Max
double ValueOpenE=92.9843753851826;//Open Signal
bool bUseTimeCorridorE=true;//Use Time Corridor
int TradeHour=21;//Start Trading Hour
int TradeMinute=3;//Start Trading Minute
int TradeHourEnd=0;//End Trading Hour
int TradeMinuteEnd=50;//End Trading Minute
double ValueCloseE=0.001;//Close Signal

input double MinLotE=0.01;//Min Lot
input double Lot=0.1;//Lot ( Without variation )
input double MaxLotE=1.0;//Max Lot
input double LotMultiplierE=2.0;//Martin Lot Multiplier
///

input ENUM_ORDER_TYPE_FILLING FILLING_E=ORDER_FILLING_FOK;//Order Filling Type

input bool bInitBuy=true;//Init Buy Trades
input bool bInitSell=true;//Init Sell Trades
////////стоплосс и тейк профит и проскальзывание
input int SLE=3000;//Stop Loss Points
input int TPE=3000;//Take Profit Points
//Лот
input bool bInitLotControl=false;//Lot Auto Control
input double DEPOSITTOMINLOTE=100.0;//Deposit For Lot
////////переменные для спреда
bool bInitSpreadControl=true;//Spread Control Init
int SpreadE=100;//Max Spread
int SpreadCloseE=100;//Spread For Close Max
input int MagicC=679034;//Magic
datetime PrevTimeAlpha=0;

////////////////////////////для mql4
//директивы назначенных констант

#define MODE_TRADES 0
#define MODE_HISTORY 1

#define SELECT_BY_POS 0
#define SELECT_BY_TICKET 1

#define OP_BUY DEAL_TYPE_BUY 
#define OP_SELL DEAL_TYPE_SELL

#define MODE_SPREAD 0
#define MODE_STOPLEVEL 1

#define MODE_MINLOT 2
#define MODE_MAXLOT 3

#define MODE_LOTSTEP 4
#define MODE_TICKVALUE 5

#define MODE_MARGINREQUIRED 6
#define MODE_SWAPLONG 7
#define MODE_SWAPSHORT 8
//

//////////переменные для переноса в mql5
double Close[];
double Open[];
double High[];
double Low[];
datetime Time[];
double Bid;
double Ask;
double Point=_Point;
int Bars=1000;
int BarsPrev=Bars;
int PositionHistory=0;

int pool0;
MqlTick TickAlphaPsi;

int TMagic0=0;
int TMagic1=0;
ENUM_ORDER_TYPE_FILLING FILLING=ORDER_FILLING_RETURN;
//////////////////////++++++++++++++++++++++++

///////////////функции для предопределенных массивов Mql5

void DimensionAllMQL5Values()//////////////////////////////
   {
   ArrayResize(Close,Bars-1,0);
   ArrayResize(Open,Bars-1,0);   
   ArrayResize(Time,Bars-1,0);
   ArrayResize(High,Bars-1,0);
   ArrayResize(Low,Bars-1,0);
   }

void CalcAllMQL5Values()///////////////////////////////////
   {
   ArraySetAsSeries(Close,false);                        
   ArraySetAsSeries(Open,false);                           
   ArraySetAsSeries(High,false);                        
   ArraySetAsSeries(Low,false);                              
   ArraySetAsSeries(Time,false);                                                            
   CopyClose(_Symbol,_Period,0,Bars-1,Close);
   CopyOpen(_Symbol,_Period,0,Bars-1,Open);   
   CopyHigh(_Symbol,_Period,0,Bars-1,High);
   CopyLow(_Symbol,_Period,0,Bars-1,Low);
   CopyTime(_Symbol,_Period,0,Bars-1,Time);
   ArraySetAsSeries(Close,true);
   ArraySetAsSeries(Open,true);
   ArraySetAsSeries(High,true);                        
   ArraySetAsSeries(Low,true);
   ArraySetAsSeries(Time,true);
   SymbolInfoTick(Symbol(),TickAlphaPsi);
   Bid=TickAlphaPsi.bid;
   Ask=TickAlphaPsi.ask;
   }
////////////////////////////////////////////////////////////

//////////////функции для совмещения исходных библиотек mql4 с mql5
////////////////////////////////////////////////////////////

ENUM_DAY_OF_WEEK DayOfWeek()
   {
   MqlDateTime TimeInfo;
   TimeToStruct(TimeCurrent(),TimeInfo);
   ENUM_DAY_OF_WEEK rez=ENUM_DAY_OF_WEEK(TimeInfo.day_of_week);
   
   return rez;
   }
   
ENUM_DAY_OF_WEEK TimeDayOfWeek(datetime Time0)
   {
   MqlDateTime TimeInfo;
   TimeToStruct(Time0,TimeInfo);
   ENUM_DAY_OF_WEEK rez=ENUM_DAY_OF_WEEK(TimeInfo.day_of_week);
   
   return rez;
   }
   
int TimeHour(datetime Time0)
   {
   MqlDateTime TimeInfo;
   TimeToStruct(Time0,TimeInfo);
   int rez=int(TimeInfo.hour);
   
   return rez;
   }
   
int TimeMinute(datetime Time0)
   {
   MqlDateTime TimeInfo;
   TimeToStruct(Time0,TimeInfo);
   int rez=int(TimeInfo.min);
   
   return rez;
   }                     

double AccountFreeMargin()
   {
   double rez;
   rez=AccountInfoDouble(ACCOUNT_MARGIN_FREE);   
   return rez;
   }

double AccountBalance()
   {
   double rez;
   rez=AccountInfoDouble(ACCOUNT_BALANCE);
   return rez;
   }

double StrToDouble(string str0)
   {
   double rez;
   rez=StringToDouble(str0);
   return rez;
   }


double MarketInfo(string Symbol0,int mode0)
   {
   double rez=0;
   if ( mode0 == MODE_SPREAD )
      {
      rez=double(SymbolInfoInteger(Symbol0,SYMBOL_SPREAD));            
      }
   if ( mode0 == MODE_STOPLEVEL )
      {
      rez=double(SymbolInfoInteger(Symbol0,SYMBOL_TRADE_STOPS_LEVEL));                  
      }
   if ( mode0 == MODE_MINLOT )
      {
      rez=SymbolInfoDouble(Symbol0,SYMBOL_VOLUME_MIN);      
      }
   if ( mode0 == MODE_MAXLOT )
      {
      rez=SymbolInfoDouble(Symbol0,SYMBOL_VOLUME_MAX);            
      }
   if ( mode0 == MODE_LOTSTEP )
      {
      rez=SymbolInfoDouble(Symbol0,SYMBOL_VOLUME_STEP);                  
      }                                                                          
   if ( mode0 == MODE_TICKVALUE )
      {
      rez=SymbolInfoDouble(Symbol0,SYMBOL_TRADE_TICK_VALUE);                        
      }
   if ( mode0 == MODE_MARGINREQUIRED )
      {
      bool b1=OrderCalcMargin(ORDER_TYPE_BUY,Symbol0,1.0,Close[0],rez);
      }
   if ( mode0 == MODE_SWAPLONG )
      {
      rez=SymbolInfoDouble(Symbol0,SYMBOL_SWAP_LONG);                        
      }                                                  
   if ( mode0 == MODE_SWAPSHORT )
      {
      rez=SymbolInfoDouble(Symbol0,SYMBOL_SWAP_SHORT);                        
      }                                                                                                                                                                                                                                                                                      
   return rez;
   }

string TimeToStr(datetime time0)
   {
   string rez="";
   rez=TimeToString(time0);
   return rez;
   }

int Hour()
   {
   int rez;
   MqlDateTime C1Info;
   TimeToStruct(TimeCurrent(),C1Info);
   rez=C1Info.hour;
   return rez;
   }

int Minute()
   {
   int rez;
   MqlDateTime C1Info;
   TimeToStruct(TimeCurrent(),C1Info);
   rez=C1Info.min;
   return rez;
   }


bool OrderSend0(string Symbol0,ENUM_ORDER_TYPE OrderType0,double Lot0,double Price01,int Slippage0,double Sl0,double Tp0,string Comment0,int Magic0,datetime Expiration0,color Color0)
   {
   bool rez=false;
   bool mrez;
   double margin,free_margin=AccountInfoDouble(ACCOUNT_MARGIN_FREE);
      
   MqlTradeRequest OrderData;
   MqlTradeResult OrderDataRez;
   ZeroMemory(OrderData);
   ZeroMemory(OrderDataRez);   
   OrderData.action=TRADE_ACTION_DEAL;
   OrderData.type_filling=FILLING;
   OrderData.symbol=Symbol0;
   OrderData.type=OrderType0;
   OrderData.volume=Lot0;
   OrderData.price=Price01;
   OrderData.expiration=Expiration0;
   OrderData.sl=Sl0;
   OrderData.tp=Tp0;  
   OrderData.comment=Comment0;
   OrderData.magic=Magic0;
   OrderData.deviation=Slippage0;
   
   mrez=OrderCalcMargin(OrderType0,Symbol0,Lot0,Price01,margin);
   
   if(margin>free_margin)
     {
      //--- сообщим об ошибке и вернем false
      Print("Not enough money for ",EnumToString(OrderType0)," ",Lot0," ",Symbol0);
      return(false);
     }
   else
      {   
      rez=OrderSend(OrderData,OrderDataRez);
      }          
   
   return rez;
   }


double OrderLots()
   {
   double rez=0;
   
   if ( pool0 == MODE_TRADES )
      {
      rez=PositionGetDouble(POSITION_VOLUME);
      }
      
   if ( pool0 == MODE_HISTORY )
      {
      rez=HistoryDealGetDouble(PositionHistory,DEAL_VOLUME);
      } 
      
   return rez;
   }

double OrderProfitPoints()
   {
   ulong ticket;
   double profit=0.0;
        
   if((ticket=HistoryDealGetTicket(PositionHistory)) > 0) profit=(HistoryDealGetDouble(ticket,DEAL_PROFIT)/HistoryDealGetDouble(ticket,DEAL_VOLUME))/MarketInfo(CurrentSymbol,MODE_TICKVALUE);
         
   return profit;
   }

int OrderTicket()
   {
   int rez=0;
   
   if ( pool0 == MODE_TRADES )
      {
      rez=int(PositionGetInteger(POSITION_TICKET));
      }
      
   if ( pool0 == MODE_HISTORY )
      {
      rez=int(HistoryDealGetInteger(PositionHistory,DEAL_TICKET));
      } 
      
   return rez;
   }

ENUM_DEAL_TYPE OrderType()
   {
   ENUM_DEAL_TYPE rez=OP_BUY;
   
   
   if ( pool0 == MODE_TRADES )
      {
      rez=ENUM_DEAL_TYPE(PositionGetInteger(POSITION_TYPE));
      }
      
   if ( pool0 == MODE_HISTORY )
      {
      rez=ENUM_DEAL_TYPE(HistoryDealGetInteger(PositionHistory,DEAL_TYPE));
      } 
      

   return rez;
   }



int OrderMagicNumber()
   {
   int rez;
   rez=0;
   
   if ( pool0 == MODE_TRADES )
      {
      rez=int(PositionGetInteger(POSITION_MAGIC));
      }
      
   if ( pool0 == MODE_HISTORY )
      {
      HistorySelect(0,TimeCurrent());
      rez=int(HistoryDealGetInteger(PositionHistory,DEAL_MAGIC));
      } 
   
   return rez;   
   }

string OrderSymbol()
   {
   string rez;
   rez="";

   
   if ( pool0 == MODE_TRADES )
      {
      rez=PositionGetString(POSITION_SYMBOL);
      }
      
   if ( pool0 == MODE_HISTORY )
      {
      rez=HistoryDealGetString(PositionHistory,DEAL_SYMBOL);
      } 
      
   
   return rez;
   }

bool OrderSelect0( 
int index, // индекс или тикет ордера 
int select, // флаг способа выбора 
int pool=MODE_TRADES // источник данных для выбора 
)
   {
   bool rez=false;
   pool0=pool;
   if ( pool0 == MODE_TRADES )
      {
      rez=PositionSelect(Symbol());
      }
      
   if ( pool0 == MODE_HISTORY )
      {
      HistorySelect(0,TimeCurrent());      
      rez=HistoryDealSelect(HistoryDealGetTicket(index));
      PositionHistory=int(HistoryDealGetTicket(index));
      } 
   return rez;
   }

int OrdersTotal0()
   {
   int rez;
   rez=PositionsTotal();
   return rez;
   }

int OrdersHistoryTotal()
   {
   int rez;
   HistorySelect(0,TimeCurrent());
   rez=HistoryDealsTotal();
   return rez;
   }
////////////////////////////для mql4


///////дополнительно

int HourCorrect(int hour0)
   {
   int rez=0;
   if ( hour0 < 24 && hour0 > 0 )
      {
      rez=hour0;
      }
   return rez;
   }
   
int MinuteCorrect(int minute0)
   {
   int rez=0;
   if ( minute0 < 60 && minute0 > 0 )
      {
      rez=minute0;
      }
   return rez;      
   }     

/////////********/////////********//////////***********/////////
void BuyF()
   {
   bool ord;
   int OrdersG0=0;
   double DtA;
   double SLTemp0=MathAbs(SLE);
   double TPTemp0=MathAbs(TPE);   
   for ( int i=0; i<OrdersTotal0(); i++ )
      {
      ord=OrderSelect0( i, SELECT_BY_POS, MODE_TRADES );
      if ( OrderSymbol() == Symbol() &&  OrderMagicNumber() == MagicC )
         {
         OrdersG0++;
         }
      }
   DtA=double(TimeCurrent())-GlobalVariableGet("TimeStart161");
   if ( PositionsTotal() == 0 && (DtA > 0 || DtA < 0) && bInitBuy == true )
      {
      CheckForOpen(MagicC,OP_BUY,Bid,Ask,Close[0],int(SLTemp0),int(TPTemp0),MathAbs(Lot),Symbol(),0,NULL,bInitLotControl,bInitSpreadControl,SpreadE);
      }
   }
   
void SellF()
   {
   bool ord;
   int OrdersG0=0;
   double DtA;
   double SLTemp0=MathAbs(SLE);
   double TPTemp0=MathAbs(TPE);   
   for ( int i=0; i<OrdersTotal0(); i++ )
      {
      ord=OrderSelect0( i, SELECT_BY_POS, MODE_TRADES );
      if ( OrderSymbol() == Symbol() && OrderMagicNumber() == MagicC )
         {
         OrdersG0++;
         }
      }
   DtA=double(TimeCurrent())-GlobalVariableGet("TimeStart161");
   if (  PositionsTotal() == 0 && (DtA > 0 || DtA < 0) && bInitSell == true )
      {
      CheckForOpen(MagicC,OP_SELL,Bid,Ask,Close[0],int(SLTemp0),int(TPTemp0),MathAbs(Lot),Symbol(),0,NULL,bInitLotControl,bInitSpreadControl,SpreadE);   
      }
   }
   
   
void CloseSellF()
   {
      for ( int i=PositionsTotal()-1; i>=0; i-- )
         {
         if ( OrderSymbol() == Symbol() &&  OrderType() == OP_SELL && OrderMagicNumber() == MagicC && (!bInitSpreadControl || (bInitSpreadControl && MarketInfo(Symbol(),MODE_SPREAD) <= SpreadCloseE)) )
            {
            if(m_position.SelectByIndex(i)) m_trade.PositionClose(m_position.Ticket());  
            }
         }
   }
   
void CloseBuyF()
   {
      for ( int i=PositionsTotal()-1; i>=0; i-- )
         {
         if ( OrderSymbol() == Symbol() &&  OrderType() == OP_BUY && OrderMagicNumber() == MagicC && (!bInitSpreadControl || (bInitSpreadControl && MarketInfo(Symbol(),MODE_SPREAD) <= SpreadCloseE)) )
            {
            if(m_position.SelectByIndex(i)) m_trade.PositionClose(m_position.Ticket());          
            }
         }

   }                      

   
double Days()
   {
   if ( double(Time[0] - DatetimeStart) > 0 ) return double(Time[0] - DatetimeStart)/86400.0;
   else return 0.0;
   }
  

double CalcMultiplierLinearIncrease()//посчитаем следующий лот увеличения для локальных участков
   {
   double EquivalentTime=Days()*86400.0;
   double LotFT=(EquivalentTime/double(DaysToFuture*86400.0))*double(MaxLotE-MinLotE) + MinLotE;
   if ( EquivalentTime <= 0.0 ) return MinLotE;
   else return LotFT;
   }
   
double CalcMultiplierLinearDecrease()//посчитаем следующий лот уменьшения для локальных участков
   {
   double EquivalentTime=Days()*86400.0;
   Print(Days());
   double LotFT=MaxLotE-(EquivalentTime/double(DaysToFuture*86400.0))*double(MaxLotE-MinLotE);
   if ( EquivalentTime <= 0.0 ) return MaxLotE;
   else return LotFT;
   }

void CheckForOpen(int Magic0,int OrdType,double PriceBid,double PriceAsk,double PriceClose0,int SL0,int TP0,double Lot0,string Symbol0,datetime Expiration0,string Comment0,bool bLotControl0,bool bSpreadControl0,int Spread0)
   {
   double LotTemp=Lot0;
   double SpreadLocal=MarketInfo(Symbol(),MODE_SPREAD);
   double LotAntiError=MarketInfo(Symbol(),MODE_MINLOT);

   if ( (SpreadLocal <= Spread0 && bSpreadControl0 == true ) || ( bSpreadControl0 == false )   )                    
      {   
      if ( bLotControl0 == false && LotMode == SIMPLE_LOT )
         {
         LotTemp=Lot0;
         }
      if ( bLotControl0 == true && LotMode == SIMPLE_LOT )
         {
         if ( DEPOSITTOMINLOTE > 0.0 ) LotTemp=Lot0*(AccountBalance()/DEPOSITTOMINLOTE);
         else LotTemp=Lot0;
         }

      if ( LotMode == VARIATION_LOCAL_INCREASE )
         {
         LotTemp=CalcMultiplierLinearIncrease();
         }
      if ( LotMode == VARIATION_LOCAL_DECREASE )
         {
         LotTemp=CalcMultiplierLinearDecrease();
         } 
      if ( LotMode == MARTINGALE )
         {
         LotTemp=CalcMartinLot(LotTemp);
         } 
         
      LotAntiError=GetLotAniError(LotTemp);
      if ( LotAntiError <= 0 )
         {
         //Print("TOO Low  Free Margin Level !");
         }
         
      if ( OrdType == OP_SELL && LotAntiError > 0.0 )
         {
         GlobalVariableSet("TimeStart161",double(TimeCurrent()) );
         m_trade.Sell(LotAntiError,Symbol0,Bid,Bid+SL0*Point,Bid-TP0*Point);
         }
      if ( OrdType == OP_BUY && LotAntiError > 0.0 )
         {
         GlobalVariableSet("TimeStart161",double(TimeCurrent()) );
         m_trade.Buy(LotAntiError,Symbol0,Ask,Ask-SL0*Point,Ask+TP0*Point);
         }                     
      }
      
   }

double GetLotAniError(double InputLot)
   {
   double Free = AccountFreeMargin();
   double margin = MarketInfo(Symbol(),MODE_MARGINREQUIRED);
   double minLot = MarketInfo(Symbol(),MODE_MINLOT);
   double Max_Lot = MarketInfo(Symbol(),MODE_MAXLOT);
   double Step = MarketInfo(Symbol(),MODE_LOTSTEP);
   double Lot13;
   int LotCorrection;
   LotCorrection=int(MathFloor(InputLot/Step));
   Lot13=LotCorrection*Step;   
   if(Lot13<=minLot) Lot13 = minLot;
   if(Lot13>=Max_Lot) Lot13 = Max_Lot;
   
   if( Lot13*margin>=Free ) Lot13=-1.0;

   return Lot13;
   }

 
bool bTimeInterval(int HourStart0,int MinuteStart0,int HourEnd0,int MinuteEnd0,bool bInitPCTime0)
   {
   bool rez=false;
   
   if ( (Hour() >= HourStart0 && Hour() <= HourEnd0 && Minute() >= MinuteStart0 && Minute() <= MinuteEnd0 && bInitPCTime0==false) || ( TimeHour(TimeLocal()) >= HourStart0 && TimeHour(TimeLocal()) <= HourEnd0 && TimeMinute(TimeLocal()) >= MinuteStart0 && TimeMinute(TimeLocal()) <= MinuteEnd0 && bInitPCTime0==true) )
      {
      rez=true;
      }
      
   return rez;
   } 

int CorrectLevels(int level0)
   {
   int rez;
   int ZeroLevel0=int(MathAbs(MarketInfo(Symbol(),MODE_STOPLEVEL))+MathAbs(MarketInfo(Symbol(),MODE_SPREAD))+1);

   if ( MathAbs(level0) > ZeroLevel0 )
      {
      rez=int(MathAbs(level0));
      }
   else
      {
      rez=ZeroLevel0;
      }   
   return rez;
   }


void CalcTimer()
   {
   if ( Time[1] > PrevTimeAlpha )
       {
       if ( PrevTimeAlpha > 0 )
          {
          PrevTimeAlpha=Time[1];
          PrevSpread=Spread;
          PrevHighSpread=HighSpread;
          PrevLowSpread=LowSpread;
          Spread=int(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD));
          HighSpread=Spread;
          LowSpread=Spread;
         
          LastHigh=Close[0];
          LastLow=Close[0];
		  
          Trade();
          if ( Days() > DaysToFuture )
             {
             CloseBuyF();
             CloseSellF();
             Print("the time of the projected work has come to an end, shutdown...");
             ExpertRemove();
             }
          }
       else
          {
          PrevTimeAlpha=Time[1];
          }
       }
   }


//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
  FILLING=FILLING_E;  
  BarsPrev=0;
  m_trade.SetExpertMagicNumber(MagicC);
  DimensionAllMQL5Values();
  CreateSimpleInterface();
  UpdateStatus();
  return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  DeleteSimpleInterface();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
  CalcAllMQL5Values();
  CalcTimer();
  UpdateStatus();
  }
//+------------------------------------------------------------------+

///////////////////////////////рабочий код
string CurrentSymbol=Symbol();

bool bDay()
   {
   MqlDateTime T;
   TimeToStruct(Time[0],T);
   for ( int i=0; i<ArraySize(DaysToTrade); i++ )
      {
      if ( T.day_of_week == DaysToTrade[i] ) return true;
      }
   return false;
   }

void Trade()
   {
   double Value;
   Value=PolinomTrade();
   MqlTick LastTick;
   SymbolInfoTick(Symbol(),LastTick);
   MqlDateTime tm;
   TimeToStruct(Time[0],tm);
   int MinuteEquivalent=tm.hour*60+tm.min;
   int BorderMinuteStartTrade=HourCorrect(TradeHour)*60+MinuteCorrect(TradeMinute);
   int BorderMinuteEndTrade=HourCorrect(TradeHourEnd)*60+MinuteCorrect(TradeMinuteEnd);
   
   if ( bUseTimeCorridorE && bCloseInOutOfTime && BorderMinuteStartTrade > BorderMinuteEndTrade )
      {
      if ( MinuteEquivalent>=BorderMinuteEndTrade && MinuteEquivalent<= BorderMinuteStartTrade )
         {
         CloseBuyF();
         CloseSellF();
         }        
      }
   if ( bUseTimeCorridorE && bCloseInOutOfTime && BorderMinuteStartTrade <= BorderMinuteEndTrade )
      {
      if ( !(MinuteEquivalent>=BorderMinuteStartTrade && MinuteEquivalent<= BorderMinuteEndTrade) )
         {
         CloseBuyF();
         CloseSellF();
         }        
      }
   
   if ( Value > ValueCloseE)
      {
      if ( !bInvert )
         {
         CloseBuyF();
         }      
      else 
         {
         CloseSellF();
         }
      }
      
   if ( Value < -ValueCloseE)
      {
      if ( !bInvert )
         {
         CloseSellF();
         }      
      else 
         {
         CloseBuyF();
         }      
      }   
   
   if ( !bUseTimeCorridorE )
      {
      if ( Days() <= DaysToFuture && Value > ValueOpenE && Value <= ValueOpenEMax )
         {
         if ( !bInvert ) SellF();
         else BuyF();
         }
      
      if ( Days() <= DaysToFuture && Value < -ValueOpenE && Value >= -ValueOpenEMax )
         {
         if ( !bInvert ) BuyF();
         else SellF();
         }      
      }
   else
      {
      if ( BorderMinuteStartTrade > BorderMinuteEndTrade && bDay() )
         {
         if ( !(MinuteEquivalent>=BorderMinuteEndTrade && MinuteEquivalent<= BorderMinuteStartTrade) )
            {
            if ( Days() <= DaysToFuture && Value > ValueOpenE && Value <= ValueOpenEMax )
               {
               if ( !bInvert ) SellF();
               else BuyF();
               }
      
            if ( Days() <= DaysToFuture && Value < -ValueOpenE && Value >= -ValueOpenEMax )
               {
               if ( !bInvert ) BuyF();
               else SellF();
               }
            }        
         }
      if ( BorderMinuteStartTrade <= BorderMinuteEndTrade && bDay() )
         {
         if ( MinuteEquivalent>=BorderMinuteStartTrade && MinuteEquivalent<= BorderMinuteEndTrade )
            {
            if ( Days() <= DaysToFuture && Value > ValueOpenE && Value <= ValueOpenEMax )
               {
               if ( !bInvert ) SellF();
               else BuyF();
               }
      
            if ( Days() <= DaysToFuture && Value < -ValueOpenE && Value >= -ValueOpenEMax )
               {
               if ( !bInvert ) BuyF();
               else SellF();
               }
            }        
         }      
      }

   if ( bPrintValue ) Print("Value="+DoubleToString(Value));       
   }
   
double Val;
int iterator;
double PolinomTrade()//полином для торговли
   {
   Val=0;
   iterator=0;

   if (Method == "PHYSICS")//новый метод на простейшей физике открытия и закрытия
   {
       for (int i = 0; i < CNum; i++)
       {
           double Ct = 0;
           iterator = 0;
           Ct += C1[iterator];
           iterator++;
           for (int j = 0; j < DeepBruteX ; j++)//от глубины зависит количество слагаемых
           {
               if (C1[iterator + 1] != 0) Ct += C1[iterator+2] * MathPow(double(i + 1), C1[iterator] / C1[iterator + 1]);
               else Ct = 100000000.0;
               iterator +=3;
           }

           if ( Ct != 0.0  ) Val +=  ( (Close[i+1]-Open[i+1]) / Point ) / Ct;
       }
       return Val;
   }   

   if ( Method == "TEYLOR" )
      {
      if ( DeepBruteX <= 1 )
         {
		 for ( int i=0; i<CNum; i++ )
		   {
		   Val+=C1[iterator]*(Close[i+1]-Open[i+1])/Point;
		   iterator++;
		   }

		 for ( int i=0; i<CNum; i++ )
		   {
		   Val+=C1[iterator]*(High[i+1]-Open[i+1])/Point;
		   iterator++;
		   }

		 for ( int i=0; i<CNum; i++ )
		   {
		   Val+=C1[iterator]*(Open[i+1]-Low[i+1])/Point;
		   iterator++;
		   }

		 for ( int i=0; i<CNum; i++ )
		   {
		   Val+=C1[iterator]*(High[i+1]-Close[i+1])/Point;
		   iterator++;
		   }

		 for ( int i=0; i<CNum; i++ )
		   {
		   Val+=C1[iterator]*(Close[i+1]-Low[i+1])/Point;
		   iterator++;
		   }         

         return Val;   
         }
      else
         {
         CalcDeep(C1,CNum,DeepBruteX);
         return ValStart;
         }      
      }
   if ( Method == "FOURIER" )
      {
	  for ( int i=0; i<CNum; i++ )
		{
		Val+=C1[iterator]*MathSin(C1[iterator+1]*(Close[i+1]-Open[i+1])/Point)+C1[iterator+2]*MathCos(C1[iterator+3]*(Close[i+1]-Open[i+1])/Point);
		iterator+=4;
		}

	  for ( int i=0; i<CNum; i++ )
		{
		Val+=C1[iterator]*MathSin(C1[iterator+1]*(High[i+1]-Open[i+1])/Point)+C1[iterator+2]*MathCos(C1[iterator+3]*(High[i+1]-Open[i+1])/Point);
		iterator+=4;
		}

	  for ( int i=0; i<CNum; i++ )
		{
		Val+=C1[iterator]*MathSin(C1[iterator+1]*(Open[i+1]-Low[i+1])/Point)+C1[iterator+2]*MathCos(C1[iterator+3]*(Open[i+1]-Low[i+1])/Point);
		iterator+=4;
		}

	  for ( int i=0; i<CNum; i++ )
		{
		Val+=C1[iterator]*MathSin(C1[iterator+1]*(High[i+1]-Close[i+1])/Point)+C1[iterator+2]*MathCos(C1[iterator+3]*(High[i+1]-Close[i+1])/Point);
		iterator+=4;
		}

	  for ( int i=0; i<CNum; i++ )
		{
		Val+=C1[iterator]*MathSin(C1[iterator+1]*(Close[i+1]-Low[i+1])/Point)+C1[iterator+2]*MathCos(C1[iterator+3]*(Close[i+1]-Low[i+1])/Point);
		iterator+=4;
		}
			
      return Val;
      }
   return 0.0;      
   }


///фрактальный подсчет чисел
double ValW;//число куда умножаем все(а потом его прибавляем к ValStart)
uint NumC;//текущее число для коэффициента
double ValStart;//число куда суммируем все
void Deep(double &Ci0[],int Nums,int deepC,int deepStart,double Val0=1.0)//промежуточный фрактал
   {
   for ( int i=0; i<Nums; i++ )
	 {
	 if (deepC > 1)
		{
		ValW=(Close[i+1]-Open[i+1])*Val0;
		Deep(Ci0,Nums,deepC-1,deepStart,ValW);
		} 
	 else 
		{
		ValStart+=Ci0[NumC]*(Close[i+1]-Open[i+1])*Val0/Point;
		NumC++;
		}
	 } 
  
   for ( int i=0; i<Nums; i++ )
	 {
	 if (deepC > 1)
		{
		ValW=(High[i+1]-Open[i+1])*Val0;
		Deep(Ci0,Nums,deepC-1,deepStart,ValW);
		} 
	 else 
		{
		ValStart+=Ci0[NumC]*(High[i+1]-Open[i+1])*Val0/Point;
		NumC++;
		}
	 }

   for ( int i=0; i<Nums; i++ )
	 {
	 if (deepC > 1)
		{
		ValW=(Open[i+1]-Low[i+1])*Val0;
		Deep(Ci0,Nums,deepC-1,deepStart,ValW);
		} 
	 else 
		{
		ValStart+=Ci0[NumC]*(Open[i+1]-Low[i+1])*Val0/Point;
		NumC++;
		}
	 }

   for ( int i=0; i<Nums; i++ )
	 {
	 if (deepC > 1)
		{
		ValW=(High[i+1]-Close[i+1])*Val0;
		Deep(Ci0,Nums,deepC-1,deepStart,ValW);
		} 
	 else 
		{
		ValStart+=Ci0[NumC]*(High[i+1]-Close[i+1])*Val0/Point;
		NumC++;
		}
	 }

   for ( int i=0; i<Nums; i++ )
	 {
	 if (deepC > 1)
		{
		ValW=(Close[i+1]-Low[i+1])*Val0;
		Deep(Ci0,Nums,deepC-1,deepStart,ValW);
		} 
	 else 
		{
		ValStart+=Ci0[NumC]*(Close[i+1]-Low[i+1])*Val0/Point;
		NumC++;
		}
	 }   
   }
   
void CalcDeep(double &Ci0[],int Nums,int deepC=1)
   {
   NumC=0;
   ValStart=0.0;
   for ( int i=0; i<deepC; i++ )
      {
      Deep(Ci0,Nums,i+1,i+1);
      }   
   }   
///
///фрактальный подсчет числа коэффициентов
int NumCAll=0;//размер массива коэффициентов
void DeepN(int Nums,int deepC=1)//промежуточный фрактал
   {
   for ( int i=0; i<Nums*5; i++ )
      {
      if (deepC > 1) DeepN(Nums,deepC-1);
      else NumCAll++;
      }
   }

void CalcDeepN(int Nums,int deepC=1)
   {
   NumCAll=0;
   for ( int i=0; i<deepC; i++ ) DeepN(Nums,i+1);
   }
///

///
double CalcMartinLot(double BasicLot)//вычисление лота для мартина
   {
   bool ord;
   double TotalLot=0;
   HistorySelect(TimeCurrent()-HistoryDaysLoadI*86400,TimeCurrent());
   for ( int i=HistoryDealsTotal()-1; i>=0; i-- )
      {
      ulong ticket=HistoryDealGetTicket(i);
      ord=HistoryDealSelect(ticket);
      if ( ord && HistoryDealGetString(ticket,DEAL_SYMBOL) == _Symbol 
      && HistoryDealGetInteger(ticket,DEAL_MAGIC) == MagicC 
      && HistoryDealGetInteger(ticket,DEAL_ENTRY) == DEAL_ENTRY_OUT )
         {
         if ( HistoryDealGetDouble(ticket,DEAL_PROFIT) < 0 )
            {
            return HistoryDealGetDouble(ticket,DEAL_VOLUME) * MathAbs(LotMultiplierE);
            }
         else
            {
            return BasicLot;
            }
         }
      }
   return BasicLot;
   }
///

//////////////////////////////////////интерфейс

////функции для создания прямоугольника, текста, кнопки***********************
//создание прямоугольной рамки
bool RectLabelCreate(
const long chart_ID=0, // ID графика 
const string name="RectLabel", // имя метки 
const int sub_window=0, // номер подокна 
const int x=0, // координата по оси X 
const int y=0, // координата по оси Y 
const int width=50, // ширина 
const int height=18, // высота 
const color back_clr=C'236,233,216', // цвет фона 
const ENUM_BORDER_TYPE border=BORDER_SUNKEN, // тип границы const 
ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, // угол графика для привязки 
const color clr=clrRed, // цвет плоской границы (Flat) 
const ENUM_LINE_STYLE style=STYLE_SOLID, // стиль плоской границы 
const int line_width=1, // толщина плоской границы 
const bool back=false, // на заднем плане const 
bool selection=false, // выделить для перемещений 
const bool hidden=true, // скрыт в списке объектов 
const long z_order=0) // приоритет на нажатие мышью 
{ 
//--- сбросим значение ошибки 
ResetLastError(); 
//--- создадим прямоугольную метку 
if(!ObjectCreate(chart_ID,name,OBJ_RECTANGLE_LABEL,sub_window,0,0)) 
   { 
   Print(__FUNCTION__, ": не удалось создать прямоугольную метку! Код ошибки = ",GetLastError()); 
   return(false); 
   } 
//--- установим координаты метки 
ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x); 
ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y); 
//--- установим размеры метки 
ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width); 
ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height); 
//--- установим цвет фона 
ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr); 
//--- установим тип границы 
ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_TYPE,border); 
//--- установим угол графика, относительно которого будут определяться координаты точки 
ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner); 
//--- установим цвет плоской рамки (в режиме Flat) 
ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr); 
//--- установим стиль линии плоской рамки 
ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style); 
//--- установим толщину плоской границы 
ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,line_width); 
//--- отобразим на переднем (false) или заднем (true) плане 
ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back); 
//--- включим (true) или отключим (false) режим перемещения метки мышью 
ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection); 
ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection); 
//--- скроем (true) или отобразим (false) имя графического объекта в списке объектов 
ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden); 
//--- установим приоритет на получение события нажатия мыши на графике 
ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order); 
//--- успешное выполнение 
return(true); 
}

//создание текста
bool LabelCreate(const long              chart_ID=0,               // ID графика
                 const string            name="Label",             // имя метки
                 const int               sub_window=0,             // номер подокна
                 const int               x=0,                      // координата по оси X
                 const int               y=0,                      // координата по оси Y
                 const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, // угол графика для привязки
                 const string            text="Label",             // текст
                 const string            font="Arial",             // шрифт
                 const int               font_size=10,             // размер шрифта
                 const color             clr=clrRed,               // цвет
                 const double            angle=0.0,                // наклон текста
                 const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, // способ привязки
                 const bool              back=false,               // на заднем плане
                 const bool              selection=false,          // выделить для перемещений
                 const bool              hidden=true,              // скрыт в списке объектов
                 const long              z_order=0)                // приоритет на нажатие мышью
  {
//--- сбросим значение ошибки
   ResetLastError();
//--- создадим текстовую метку
   if(!ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ": не удалось создать текстовую метку! Код ошибки = ",GetLastError());
      return(false);
     }
//--- установим координаты метки
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//--- установим угол графика, относительно которого будут определяться координаты точки
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//--- установим текст
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//--- установим шрифт текста
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//--- установим размер шрифта
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//--- установим угол наклона текста
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
//--- установим способ привязки
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//--- установим цвет
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//--- отобразим на переднем (false) или заднем (true) плане
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//--- включим (true) или отключим (false) режим перемещения метки мышью
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//--- скроем (true) или отобразим (false) имя графического объекта в списке объектов
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//--- установим приоритет на получение события нажатия мыши на графике
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//--- успешное выполнение
   return(true);
  }

//создание кнопки
bool ButtonCreate(
const long chart_ID=0,
// ID графика 
const string name="Button", 
// имя кнопки 
const int sub_window=0, 
// номер подокна 
const int x=0, 
// координата по оси X 
const int y=0, 
// координата по оси Y 
const int width=50, 
// ширина кнопки 
const int height=18, 
// высота кнопки 
const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, 
// угол графика для привязки 
const string text="Button", 
// текст 
const string font="Arial", 
// шрифт 
const int font_size=10, 
// размер шрифта 
const color clr=clrBlack, 
// цвет текста 
const color back_clr=C'236,233,216', 
// цвет фона 
const color border_clr=clrNONE, 
// цвет границы 
const bool state=false, 
// нажата/отжата 
const bool back=false, 
// на заднем плане 
const bool selection=false, 
// выделить для перемещений 
const bool hidden=true, 
// скрыт в списке объектов 
const long z_order=0) // приоритет на нажатие мышью 
{ 
//--- сбросим значение ошибки 
ResetLastError(); 
//--- создадим кнопку 
if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0)) 
   { 
   Print(__FUNCTION__, ": не удалось создать кнопку! Код ошибки = ",GetLastError()); 
   return(false); 
   } 
//--- установим координаты кнопки 
ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x); 
ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y); 
//--- установим размер кнопки 
ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width); 
ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height); 
//--- установим угол графика, относительно которого будут определяться координаты точки 
ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner); 
//--- установим текст 
ObjectSetString(chart_ID,name,OBJPROP_TEXT,text); 
//--- установим шрифт текста 
ObjectSetString(chart_ID,name,OBJPROP_FONT,font); 
//--- установим размер шрифта 
ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size); 
//--- установим цвет текста 
ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr); 
//--- установим цвет фона 
ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr); 
//--- установим цвет границы 
ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr); 
//--- отобразим на переднем (false) или заднем (true) плане 
ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back); 
//--- переведем кнопку в заданное состояние 
ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state); 
//--- включим (true) или отключим (false) режим перемещения кнопки мышью 
ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection); 
ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection); 
//--- скроем (true) или отобразим (false) имя графического объекта в списке объектов 
ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden); 
//--- установим приоритет на получение события нажатия мыши на графике 
ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order); 
//--- успешное выполнение 
return(true); 
}
////конец описания функций для создания прямоугольника, текста, кнопки*********************** 
 
 
////создание интерфейса, обновление интерфейса

//имена будущих объектов интерфейса
string OwnObjectNames[] = {
"BorderPanel",//RectLabel
"MainPanel",//RectLabel
"Name",//Label
"Balance",//Label
"Equity",//Label
"Profit",//Label
"Broker",//Label
"Leverage",//Label
"Spread",//Label
"BuyPositions",//Label
"SellPositions",//Label
"CurrentUnitsBuy",//Label
"CurrentUnitsSell",//Label
"DaysRemaining",//Label
"StartDate",//Label
"EndDate",//Label
"CloseOwn",//Button
"CloseAll",//Button
"Line-Divider1",//RectLabel разделитель 1
"Line-Divider2",//RectLabel разделитель 2
"Line-Divider3",//RectLabel разделитель 3
"Line-Divider4"//RectLabel разделитель 4
};

void UpdateStatus()//обновление состояния интерфейса
   {
   string TempText="Balance : ";
   TempText+=DoubleToString(NormalizeDouble(AccountInfoDouble(ACCOUNT_BALANCE),2),2);
   ObjectSetString(0,OwnObjectNames[3],OBJPROP_TEXT,TempText);
   TempText="Equity : ";
   TempText+=DoubleToString(NormalizeDouble(AccountInfoDouble(ACCOUNT_EQUITY),2),2);
   ObjectSetString(0,OwnObjectNames[4],OBJPROP_TEXT,TempText);
   TempText="Leverage : 1/";
   TempText+=DoubleToString(AccountInfoInteger(ACCOUNT_LEVERAGE),0);
   ObjectSetString(0,OwnObjectNames[7],OBJPROP_TEXT,TempText);
   TempText="Broker : ";
   TempText+=AccountInfoString(ACCOUNT_COMPANY);
   ObjectSetString(0,OwnObjectNames[6],OBJPROP_TEXT,TempText);
   TempText="Spread : ";
   MqlTick LastTick;
   SymbolInfoTick(_Symbol,LastTick);
   TempText+=DoubleToString((LastTick.ask-LastTick.bid)/_Point,0);
   ObjectSetString(0,OwnObjectNames[8],OBJPROP_TEXT,TempText);
   ///////////////////////////
   TempText="Buy positions : ";
   TempText+=DoubleToString(NormalizeDouble(CalculateBuyQuantity(),0),0);   
   ObjectSetString(0,OwnObjectNames[9],OBJPROP_TEXT,TempText);
   TempText="Sell positions : ";
   TempText+=DoubleToString(NormalizeDouble(CalculateSellQuantity(),0),0);      
   ObjectSetString(0,OwnObjectNames[10],OBJPROP_TEXT,TempText);
   TempText="Buy lots : ";
   TempText+=DoubleToString(NormalizeDouble(CalculateBuyLots(),3),3);   
   ObjectSetString(0,OwnObjectNames[11],OBJPROP_TEXT,TempText);
   TempText="Sell lots : ";
   TempText+=DoubleToString(NormalizeDouble(CalculateSellLots(),3),3);   
   ObjectSetString(0,OwnObjectNames[12],OBJPROP_TEXT,TempText);
   TempText="Profit : ";
   TempText+=DoubleToString(NormalizeDouble(AccountInfoDouble(ACCOUNT_EQUITY)-AccountInfoDouble(ACCOUNT_BALANCE),2),2);
   ObjectSetString(0,OwnObjectNames[5],OBJPROP_TEXT,TempText);
   ////////////////////////////
   TempText="Days remaining : ";
   if ( double(DaysToFuture)-Days() > 0 ) TempText+=DoubleToString(NormalizeDouble(double(DaysToFuture)-Days(),2),2);
   else TempText+="0, trading disabled!";
   ObjectSetString(0,OwnObjectNames[13],OBJPROP_TEXT,TempText);
   TempText="Optimization finished : ";
   MqlDateTime StartDate;
   TimeToStruct(DatetimeStart,StartDate);
   TempText+=IntegerToString(StartDate.day)+"."+IntegerToString(StartDate.mon)+"."+IntegerToString(StartDate.year);
   ObjectSetString(0,OwnObjectNames[14],OBJPROP_TEXT,TempText);
   TempText="Will trade until : ";
   MqlDateTime EndDate;
   TimeToStruct(DatetimeStart+datetime(DaysToFuture*86400),EndDate);
   TempText+=IntegerToString(EndDate.day)+"."+IntegerToString(EndDate.mon)+"."+IntegerToString(EndDate.year);
   ObjectSetString(0,OwnObjectNames[15],OBJPROP_TEXT,TempText);
   ///////////////////////////
   }

double CalculateBuyLots()//посчитать свои лоты на покупку
   {
   double Lots=0;
   bool ord;
   ulong ticket;
   for ( int i=0; i<PositionsTotal(); i++ )
      {
      ticket=PositionGetTicket(i);
      ord=PositionSelectByTicket(ticket);
      if ( ord && PositionGetInteger(POSITION_MAGIC) == MagicC && PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY )
         {
         Lots+=PositionGetDouble(POSITION_VOLUME);
         }
      }
   return Lots;   
   }
   
double CalculateSellLots()//посчитать свои лоты на продажу
   {
   double Lots=0;
   bool ord;
   ulong ticket;
   for ( int i=0; i<PositionsTotal(); i++ )
      {
      ticket=PositionGetTicket(i);
      ord=PositionSelectByTicket(ticket);
      if ( ord && PositionGetInteger(POSITION_MAGIC) == MagicC && PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL )
         {
         Lots+=PositionGetDouble(POSITION_VOLUME);
         }
      }
   return Lots;
   }
   
double CalculateBuyQuantity()//посчитать количество входов на покупку
   {
   double Positions=0;
   bool ord;
   ulong ticket;
   for ( int i=0; i<PositionsTotal(); i++ )
      {
      ticket=PositionGetTicket(i);
      ord=PositionSelectByTicket(ticket);
      if ( ord && PositionGetInteger(POSITION_MAGIC) == MagicC && PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY )
         {
         Positions++;
         }
      }
   return Positions;   
   }
   
double CalculateSellQuantity()//посчитать количество входов на продажу
   {
   double Positions=0;
   bool ord;
   ulong ticket;
   for ( int i=0; i<PositionsTotal(); i++ )
      {
      ticket=PositionGetTicket(i);
      ord=PositionSelectByTicket(ticket);
      if ( ord && PositionGetInteger(POSITION_MAGIC) == MagicC && PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL )
         {
         Positions++;
         }
      }
   return Positions;
   }        

void CloseAllI(int magic0)//закрыть все
   {
   bool ord;
   ulong Tickets[];
   int TicketsTotal=0;
   int TicketNumCurrent=0;
   ulong ticket;
   MqlTick TickS;
   
   for ( int i=0; i<PositionsTotal(); i++ )
      {
      ticket=PositionGetTicket(i);
      ord=PositionSelectByTicket(ticket);      
                         
      if ( ord && ( PositionGetInteger(POSITION_MAGIC) == magic0 || magic0 == -1 ) )
         {
         TicketsTotal=TicketsTotal+1;
         }
      }
   ArrayResize(Tickets,TicketsTotal);
         
   for ( int i=0; i<PositionsTotal(); i++ )
      {
      ticket=PositionGetTicket(i);
      ord=PositionSelectByTicket(ticket); 
                         
      if ( ord && ( PositionGetInteger(POSITION_MAGIC) == magic0 || magic0 == -1 ) && TicketNumCurrent < TicketsTotal )
         {
         Tickets[TicketNumCurrent]=ticket;
         TicketNumCurrent=TicketNumCurrent+1;
         }
      }
      
   for ( int i=0; i<TicketsTotal; i++ )
      {
      m_trade.PositionClose(Tickets[i]);       
      }                     
   }

void CreateSimpleInterface()//создаем простейший интерфейс
   {
   ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER;//привязка всех элементов в верхний левый угол
   int x=5;//смещение по "x";
   int y=15;//смещение по "y";
   int Width = 280;//ширина
   int Height = 330;//высота
   int Border = 5;//граница
   
   RectLabelCreate(0,OwnObjectNames[0],0,x,y,Width+2*Border,Height+2*Border,clrRed,BORDER_RAISED,corner,clrOrchid,STYLE_SOLID,3,false,false,true,0);//рамка
   RectLabelCreate(0,OwnObjectNames[1],0,x+Border,y+Border,Width,Height,clrCornflowerBlue,BORDER_RAISED,corner,clrOrchid,STYLE_SOLID,3,false,false,true,0);//основная панель
   //текстовые элементы
   LabelCreate(0,OwnObjectNames[2],0,x+Border+32,y+Border,corner,"AWAITER AUTO GENERATION BOT","Agency FB",17,clrSnow,0.0);//имя советника
   //
   RectLabelCreate(0,OwnObjectNames[18],0,x+Border,y+Border+25,Width,5,clrSnow,BORDER_RAISED,corner,clrOrchid,STYLE_SOLID,0,false,false,true,0);//первый разделитель   
   //текстовые элементы
   LabelCreate(0,OwnObjectNames[3],0,x+Border+2,y+17+Border+20*1,corner,"Balance : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//баланс
   LabelCreate(0,OwnObjectNames[4],0,x+Border+2,y+17+Border+20*2,corner,"Equity : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//эквити
   LabelCreate(0,OwnObjectNames[7],0,x+Border+2,y+17+Border+20*3,corner,"Leverage : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//плечо
   LabelCreate(0,OwnObjectNames[6],0,x+Border+2,y+17+Border+20*4,corner,"Broker : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//брокер
   LabelCreate(0,OwnObjectNames[8],0,x+Border+2,y+17+Border+20*5,corner,"Spread : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//спред           
   //
   RectLabelCreate(0,OwnObjectNames[19],0,x+Border,y+Border+25+100,Width,5,clrSnow,BORDER_RAISED,corner,clrOrchid,STYLE_SOLID,0,false,false,true,0);//второй разделитель   
   //текстовые элементы
   LabelCreate(0,OwnObjectNames[9],0,x+Border+2,y+17+Border+20*5+20,corner,"Buy positions : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//позиции на покупку
   LabelCreate(0,OwnObjectNames[10],0,x+Border+2,y+17+Border+20*5+20*2,corner,"Sell positions : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//позиции на продажу
   LabelCreate(0,OwnObjectNames[11],0,x+Border+2,y+17+Border+20*5+20*3,corner,"Buy lots : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//объем позиций на покупку
   LabelCreate(0,OwnObjectNames[12],0,x+Border+2,y+17+Border+20*5+20*4,corner,"Sell lots : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//объем позиций на продажу
   LabelCreate(0,OwnObjectNames[5],0,x+Border+2,y+17+Border+20*5+20*5,corner,"Profit : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//прибыль висящих позиций       
   //
   RectLabelCreate(0,OwnObjectNames[20],0,x+Border,y+Border+25+100+100,Width,5,clrSnow,BORDER_RAISED,corner,clrOrchid,STYLE_SOLID,0,false,false,true,0);//третий разделитель
   //текстовые элементы
   LabelCreate(0,OwnObjectNames[13],0,x+Border+2,y+17+Border+20*5+20*5+23,corner,"Days remaining : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//сколько дней осталось торговать
   LabelCreate(0,OwnObjectNames[14],0,x+Border+2,y+17+Border+20*5+20*5+23+20*1,corner,"Optimization finished : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//дата конца оптимизации
   LabelCreate(0,OwnObjectNames[15],0,x+Border+2,y+17+Border+20*5+20*5+23+20*2,corner,"Will trade until : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//дата до которой торгуем
   //   
   RectLabelCreate(0,OwnObjectNames[21],0,x+Border,y+Border+25+100+95+72,Width,5,clrSnow,BORDER_RAISED,corner,clrOrchid,STYLE_SOLID,0,false,false,true,0);//четвертый разделитель
   ButtonCreate(0,OwnObjectNames[16],0,x+Border+5,y+17+Border+20*5+20*5+23+20*2+20,130,25,corner,"Close own orders","Arial",11,clrSnow,clrCrimson,clrNONE,false,false,false,true,0);
   ButtonCreate(0,OwnObjectNames[17],0,x+Border+5+140,y+17+Border+20*5+20*5+23+20*2+20,130,25,corner,"Close all orders","Arial",11,clrSnow,clrBlueViolet,clrNONE,false,false,false,true,0);
   }

 
void ButtonsCheck(string sparam0)//проверка кнопок отжатие и закрытие соответствующих ордеров
   {
   if ( sparam0 == OwnObjectNames[16] )//close own
      {
      CloseAllI(MagicC);
      }
      
   if ( sparam0 == OwnObjectNames[17] )//close all
      {
      CloseAllI(-1);
      }         
   
   if ( sparam0 == OwnObjectNames[16] || sparam0 == OwnObjectNames[17] )
      {
      if ( ObjectGetInteger(0,sparam0,OBJPROP_STATE,0) )
         {
         ObjectSetInteger(0,OwnObjectNames[16],OBJPROP_STATE,false);
         ObjectSetInteger(0,OwnObjectNames[17],OBJPROP_STATE,false);
         }      
      }
   } 
 
void DeleteSimpleInterface()//удалить все элементы интерфейса
   {
   int NumObj=1;

   while ( NumObj > 0 )
      {    
      for(int i=0;i<ObjectsTotal(0);i++)
         {     
         for(int j=0;j<ArraySize(OwnObjectNames);j++)
            {
            if ( ObjectName(0,i) == OwnObjectNames[j] ) ObjectDelete(0,ObjectName(0,i));
            }
         }
      NumObj=0;   
      for(int i=0;i<ObjectsTotal(0);i++)
         {         
         for(int j=0;j<ArraySize(OwnObjectNames);j++)
            {
            if ( ObjectName(0,i) == OwnObjectNames[j] ) NumObj++;
            }     
         }         
      } 
   }

void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
  if (id == CHARTEVENT_OBJECT_CLICK )//
     {
     ButtonsCheck(sparam);
     }
  } 
///////////////////////////////////////////////////